classdef Goldnoise < handle
    %UNTITLED2 Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        fs;
        fc;
        fm;
        L_signal;
        P;
        
        code;
        L_code;
        N_code;
        code_pr_output;
        
        single_rms;
        
        cnt= 0;
        L_buffer;
        r_code;
        
        counter = 0;
        
        modulator;
        handles;
        
        
        
        
    end
    
    methods
        function self = Goldnoise(fs,fc,fm,node_attenuation)
            self.fs = fs;
            self.fc = fc;
            self.fm = fm;
            
            self.P = self.fs/self.fm;
            
            self.L_code = 511;
            self.N_code = 40;
            self.code_pr_output = 2;
            
            
            self.L_signal = self.L_code*self.P;
            self.L_buffer = self.L_signal * 4;   

            
            %initialize
            self.code = getGold(10,self.N_code, self.L_code);
            
            att_factor = 10^(-node_attenuation/10);
            self.single_rms = rms(2*self.code(1,:)-1)*att_factor;
            
            
        
        end
        
        function r_code = shuffle(self,code)
           self.cnt = mod(self.cnt+1, length(code)/3); 
           r_code = sum (code(3*self.cnt:3*self.cnt+2,:));
           r_code = round(r_code/3);
        end
        
        
        function out = step(self,snr)
            self.counter = mod(self.counter + 1,self.code_pr_output);
            noise_bpsk = sum(2*self.code(self.counter+1:self.counter+20,:)-1,1);
            
            
            desired_rms = self.single_rms/(10^(snr/10));
            init_rms = rms(noise_bpsk);
            scale_factor = desired_rms/init_rms;
            
            noise_up = scale_factor*upsample(noise_bpsk,self.P);
            
            for i = 1:self.P:self.L_signal-1
                noise_up(i:i+self.P-1) = noise_up(i);
            end
            
            out = [noise_up noise_up noise_up noise_up];
            
            
            
        end

        
    
    end
end
