classdef Turntable < handle
    %TURNTABLE Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        angle;
        speed = 5;
        accel = 1;
        
        port = '/dev/tty.UC-232AC';
        s;
        fid;
    end
    
    methods
        function self = Turntable()
            delete(instrfindall);
            self.s = serial(self.port, 'BaudRate', 9600, 'DataBits', 8, 'Parity', 'None', 'StopBits', 1);
            fopen(self.s);
            
            fprintf(self.s, 'IR');
            pause(1);
            fprintf(self.s, ['TR ' num2str(self.speed)]);
            pause(1);
            fprintf(self.s, ['TA ' num2str(self.accel)]);
            pause(1);
            fprintf(self.s, 'GH');
            pause(1);
            %out = fscanf(self.s);
        end
        
        function goToAngle(self, angle)
            self.angle = angle;
            fprintf(self.s, ['GT ' num2str(-self.angle)]);
        end
        
        function pos = getPos(self)
           nbytes = self.s.BytesAvailable;
            if (nbytes > 0)
              throw = fread(self.s,nbytes);
            end

            % send request
            fprintf(self.s,'AN');

            % get data
            text = fgetl(self.s);
            pos = -str2double(text);
            
        end
        
        function release(self)
           fclose(self.s);
           self.s = [];
           
        end
        
        function goPeriodic(self,ang)
            self.goToAngle(-ang);
            current_angle = -ang;
            
            while(1)
                pause(0.05);
                if self.getPos  == current_angle
                    current_angle = - current_angle;
                    self.goToAngle(current_angle);
                end  
           end
        end
    end
    
end

