classdef Demodulator_complex < handle
    %BPSKDEMODULATOR Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        
        
        % Input variables
        fs;
        fc;
        fm;
        l_signal;
        l_buffer;
        
        
        %
        c;
        D;
        
        % FIR LP filter
        N;
        fp;
        rp;
        rst;
        fir;
        
    end
    
    methods
        function self = Demodulator_complex(fs,fc,fm,l_signal,l_buffer)
            % Assign inputs
            self.fs = fs;
            self.fc = fc;
            self.fm = fm;
            self.l_signal = l_signal;
            self.l_buffer = l_buffer;
            
            % Initialize
            t = (0:1:(l_buffer-1))/self.fs;
            self.c = exp(-1i*2*pi*self.fc*t);
            
            %
            self.D = self.fs/self.fm;  % Decimation factor
            
            % Generate FIR LP filter
            self.N = 100;
            self.fp = self.fm/6;
            self.rp = 0.001;
            self.rst = 1E-6;
            self.fir = firDesign(self.N, self.fp, self.fs, self.rp, self.rst);
            
            
        end
        
        function [m, r_lp] = step(self, r)
            
            % Downmix the signal with local complex carrier
            r_downmix = self.c .* r;
            r_lp = self.fir.step(r_downmix')';
            
            % Decimate the input signal to fm
            r_dec = r_lp(1:self.D:end);
            
            %m = zeros(1,round(self.l_buffer/self.D/2));
            %for i = 1:2:round(self.l_buffer/self.D)-1
            %    m((i+1)/2) = r_dec(i) + r_dec(i+1);
            %end
            m = r_dec;
        end
     
    end
    
end

