function [ m ] = demodBPSK( s, L, fs, fc, fm, FIR)
%PLL Summary of this function goes here
%   Detailed explanation goes here

% Find phase, multiply by local carrier
ratio1 = fs/fc;
ratio2 = fs/fm;

xmax = max(s(1:ratio1*10));
indexMax = find(s == xmax);

t = 0:1/fs:1/fc;
I = 1:L;
U = cos(2*pi*fc.*(I-1+ratio1-indexMax(1))/fs);

mul = s.*U;

% Low-pass signal
filtered = step(FIR,mul');

% Find decision points
filteredMax = max(filtered);
indexFilteredMax = find(filtered == filteredMax);
k = indexFilteredMax;
while 1
    if (sign(filtered(k)) * sign(filtered(k+1))) == -1;
        break;
    end
    k = k+1;
end

offset = mod(k,ratio2)+ratio2/2;

% Demodulate signal
m = zeros(1,floor(L/ratio2));
j = 1;
for i=offset:ratio2:L
    m(j) = (sign(filtered(i)) + 1)/2;
    j = j+1;
end


end
