function [ s ] = modBPSK( m, L, fs, fc, fm )
%MODBPSK Summary of this function goes here
%   Detailed explanation goes here

% Transform to BPSK
m_mod = 2.*m - 1;

% Upsampling
P = fs/fm;
Ls = P*L;
phi = zeros(1,Ls);
for i = 1:L
    phi(P*i-(P-1)) = m_mod(i);
    for j = 1:P-1
        phi(P*i-(P-1)+j) = m_mod(i);
    end
end

% Create carrier and modulate
T = (Ls-1)/fs;
t = 0:1/fs:T;
c = sin(2*pi*fc.*t);
s = phi.*c;

end